package io.github.beradq.adybubbles

class Bubbles(val items: MutableList<String>, val mode: ChatPopupMode = ChatPopupMode.LOOP) : Cloneable {
    private val state = BubbleState(0)

    operator fun get(index: Int): String {
        return items[index]
    }

    class BubbleState(
        var index: Int,
    ) : Cloneable

    fun next(): String? {
        if (items.isEmpty()) return null
        val item = items[state.index]
        state.index++
        if (state.index >= items.size && mode == ChatPopupMode.LOOP) {
            state.index = 0
        }
        return item
    }

    fun resetState() {
        state.index = 0
    }

    fun random(): String {
        return items.random()
    }

    public override fun clone(): Bubbles {
        val bubbles = Bubbles(items.toMutableList(), mode)
        bubbles.state.index = state.index
        return bubbles
    }
}
