package io.github.beradq.adybubbles

inline infix fun <T, R> T.pipe(func: (T) -> R): R {
    return func(this)
}

infix fun <T, R, S> T.pipe(func: Pair<(T) -> R, (T) -> S>): Pair<R, S> {
    return func.first(this) to func.second(this)
}

inline infix fun <T, R> T.also(func: (T) -> R): T {
    func(this)
    return this
}

infix fun <F : (T) -> R, T, R> F.bind(value: T): () -> R {
    return { this(value) }
}
